//+------------------------------------------------------------------+
//|                                           MACD with crossing.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright ""
#property  link      ""
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Red
#property  indicator_color2  Blue
#property  indicator_color3  Silver
#property  indicator_width3  2
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];
double     HistogramBuffer[];
//---- globals
int        maxLines;
extern int TOP_TF;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   //
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexBuffer(2,HistogramBuffer);
   //
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"MACD-Signal");
   //
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
   IndicatorShortName("MTF-MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   DeleteLines();
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
   double crossing;
    
// Plot defined TOP_TF on to current TOP_TF   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TOP_TF); 
   
//----
   limit=Bars-counted_bars;
   // Made this MTF successfully.
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++;       
      MacdBuffer[i]=iMA(NULL,TOP_TF,FastEMA,0,MODE_EMA,PRICE_CLOSE,y)-iMA(NULL,TOP_TF,SlowEMA,0,MODE_EMA,PRICE_CLOSE,y);   
      
   }
    
     // Unable to make these MTF.  
     for(i=0,y=0;i<limit;i++)
     {      
      if (Time[i]<TimeArray[y]) y++;   
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,y);
      HistogramBuffer[i]=MacdBuffer[y] - SignalBuffer[y];
     }
     
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

